/*****************************************************\
*ϹҵѧFreescale MCU&DSPʵ
*  Init_LCD.c
*C  P  U STM32VBT6
*ԻIAR4.22 
*    ߣ 
*    : 9325Һ
*    ڣ2008829
\*****************************************************/

#include "9325_FW.h"

GPIO_InitTypeDef GPIO_InitStructure;

void Delay(vu32 nCount)
{
  for(; nCount != 0; nCount--);
}



void LCD_IO_Init(void){

  
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE, ENABLE);
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(GPIOE, &GPIO_InitStructure);
  
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(GPIOD, &GPIO_InitStructure);
  
  RST;
  CS;
  RS;
  WR;
  RD;
  }


/**************************************************\
дַĴ
\**************************************************/
//void LCD_WriteIndex_ILI9325(u16 index)
//{
// nRS;
// BUS=index;
// nWR;
// WR;
// RS;               
//}

/**************************************************\
дݺ
\**************************************************/
//void LCD_WriteData_ILI9325(u16 data)
//{
// BUS=data;
// nWR;
// WR;              
//}

/**************************************************\
ݺ
\**************************************************/
void LCD_ReadData_ILI9325(void){
 
 u16 temp=0;
  
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_Init(GPIOE, &GPIO_InitStructure);

 

 nRD;
 temp=GPIOE->IDR;
 RD;
 
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(GPIOE, &GPIO_InitStructure);
  GPIOE->ODR=temp;
}

/**************************************************\
д
\**************************************************/
void LCD_CtrlWrite_ILI9325(u16 index,u16 data) {
nCS;
LCD_WriteIndex_ILI9325();
LCD_WriteData_ILI9325();
CS;
}

/**************************************************\

\**************************************************/
void LCD_CtrlRead_ILI9325(u16 index) {
nCS;
LCD_WriteIndex_ILI9325();
LCD_ReadData_ILI9325();
CS;
}




void ILI9325(void)
{
  LCD_IO_Init();
// VCI=2.8V
//************* Reset LCD Driver ****************//
RST;
Delay(100); // Delay 1ms
nRST;
Delay(1000); // Delay 10ms // This Delay time is necessary
RST;
Delay(5000); // Delay 50 ms

//************* Start Initial Sequence **********//
LCD_CtrlWrite_ILI9325(0x00E3, 0x3008); // Set u16ernal timing
LCD_CtrlWrite_ILI9325(0x00E7, 0x0012); // Set u16ernal timing
LCD_CtrlWrite_ILI9325(0x00EF, 0x1231); // Set u16ernal timing
LCD_CtrlWrite_ILI9325(0x0001, 0x0100); // set SS and SM bit
LCD_CtrlWrite_ILI9325(0x0002, 0x0700); // set 1 line inversion
LCD_CtrlWrite_ILI9325(0x0003, 0x1030); // set GRAM write direction and BGR=1.
LCD_CtrlWrite_ILI9325(0x0004, 0x0000); // Resize register
LCD_CtrlWrite_ILI9325(0x0008, 0x020E); // set the back porch and front porch
LCD_CtrlWrite_ILI9325(0x0009, 0x0000); // set non-display area refresh cycle ISC[3:0]
LCD_CtrlWrite_ILI9325(0x000A, 0x0000); // FMARK function
LCD_CtrlWrite_ILI9325(0x000C, 0x0000); // RGB u16erface setting
LCD_CtrlWrite_ILI9325(0x000D, 0x0000); // Frame marker Position
LCD_CtrlWrite_ILI9325(0x000F, 0x0000); // RGB u16erface polarity
//*************Power On sequence ****************//
LCD_CtrlWrite_ILI9325(0x0010, 0x0000); // SAP, BT[3:0], AP, DSTB, SLP, STB
LCD_CtrlWrite_ILI9325(0x0011, 0x0007); // DC1[2:0], DC0[2:0], VC[2:0]
LCD_CtrlWrite_ILI9325(0x0012, 0x0000); // VREG1OUT voltage
LCD_CtrlWrite_ILI9325(0x0013, 0x0000); // VDV[4:0] for VCOM amplitude
Delay(250000); // Dis-charge capacitor power voltage
LCD_CtrlWrite_ILI9325(0x0010, 0x1290); // SAP, BT[3:0], AP, DSTB, SLP, STB
LCD_CtrlWrite_ILI9325(0x0011, 0x0221); // R11h=0x0221 at VCI=3.3V, DC1[2:0], DC0[2:0], VC[2:0]
Delay(5000); // Delay 50ms
LCD_CtrlWrite_ILI9325(0x0012, 0x001A); // External reference voltage= Vci;
Delay(5000); // Delay 50ms
LCD_CtrlWrite_ILI9325(0x0013, 0x1600); // R13=0F00 when R12=009E;VDV[4:0] for VCOM amplitude
LCD_CtrlWrite_ILI9325(0x0029, 0x0022); // R29=0019 when R12=009E;VCM[5:0] for VCOMH
LCD_CtrlWrite_ILI9325(0x002B, 0x000A); // Frame Rate 
Delay(5000); // Delay 50ms
LCD_CtrlWrite_ILI9325(0x0020, 0x0000); // GRAM horizontal Address
LCD_CtrlWrite_ILI9325(0x0021, 0x0000); // GRAM Vertical Address
// ----------- Adjust the Gamma Curve ----------//
LCD_CtrlWrite_ILI9325(0x0030, 0x0000);
LCD_CtrlWrite_ILI9325(0x0031, 0x0302);
LCD_CtrlWrite_ILI9325(0x0032, 0x0202);
LCD_CtrlWrite_ILI9325(0x0035, 0x0103);
LCD_CtrlWrite_ILI9325(0x0036, 0x080C);
LCD_CtrlWrite_ILI9325(0x0037, 0x0505);
LCD_CtrlWrite_ILI9325(0x0038, 0x0504);
LCD_CtrlWrite_ILI9325(0x0039, 0x0707);
LCD_CtrlWrite_ILI9325(0x003C, 0x0301);
LCD_CtrlWrite_ILI9325(0x003D, 0x1008);
//------------------ Set GRAM area ---------------//
LCD_CtrlWrite_ILI9325(0x0050, 0x0000); // Horizontal GRAM Start Address
LCD_CtrlWrite_ILI9325(0x0051, 0x00EF); // Horizontal GRAM End Address
LCD_CtrlWrite_ILI9325(0x0052, 0x0000); // Vertical GRAM Start Address
LCD_CtrlWrite_ILI9325(0x0053, 0x013F); // Vertical GRAM Start Address
LCD_CtrlWrite_ILI9325(0x0060, 0xA700); // Gate Scan Line
LCD_CtrlWrite_ILI9325(0x0061, 0x0001); // NDL,VLE, REV
LCD_CtrlWrite_ILI9325(0x006A, 0x0000); // set scrolling line
//-------------- Partial Display Control ---------//
LCD_CtrlWrite_ILI9325(0x0080, 0x0000);
LCD_CtrlWrite_ILI9325(0x0081, 0x0000);
LCD_CtrlWrite_ILI9325(0x0082, 0x0000);
LCD_CtrlWrite_ILI9325(0x0083, 0x0000);
LCD_CtrlWrite_ILI9325(0x0084, 0x0000);
LCD_CtrlWrite_ILI9325(0x0085, 0x0000);
//-------------- Panel Control -------------------//
LCD_CtrlWrite_ILI9325(0x0090, 0x0010);
LCD_CtrlWrite_ILI9325(0x0092, 0x0600);
LCD_CtrlWrite_ILI9325(0x0093, 0x0003);
LCD_CtrlWrite_ILI9325(0x0095, 0x0110);
LCD_CtrlWrite_ILI9325(0x0097, 0x0000);
LCD_CtrlWrite_ILI9325(0x0098, 0x0000);
LCD_CtrlWrite_ILI9325(0x0007, 0x0133); // 262K color and display ON
}





void LCD_ExitSleep_ILI9325(void)
{
//*************Power On sequence ******************//
LCD_CtrlWrite_ILI9325(0x0010, 0x0000); // SAP, BT[3:0], AP, DSTB, SLP
LCD_CtrlWrite_ILI9325(0x0011, 0x0000); // DC1[2:0], DC0[2:0], VC[2:0]
LCD_CtrlWrite_ILI9325(0x0012, 0x0000); // VREG1OUT voltage
LCD_CtrlWrite_ILI9325(0x0013, 0x0000); // VDV[4:0] for VCOM amplitude
Delay(100000); // Dis-charge capacitor power voltage
LCD_CtrlWrite_ILI9325(0x0010, 0x1290); // SAP, BT[3:0], AP, DSTB, SLP, STB
LCD_CtrlWrite_ILI9325(0x0011, 0x0227); // R11h=0x0221 at VCI=3.3V DC1[2:0], DC0[2:0], VC[2:0]
Delay(5000); // Delay 50ms
LCD_CtrlWrite_ILI9325(0x0012, 0x001A); // External reference voltage =Vci;
Delay(5000); // Delay 50ms
LCD_CtrlWrite_ILI9325(0x0013, 0x1600); // R13h=0x0F00 when R12=009E VDV[4:0] for VCOM amplitude
LCD_CtrlWrite_ILI9325(0x0029, 0x0022); // R29h=0x000C when R12=009E VCM[5:0] for VCOMH
Delay(5000); // Delay 50ms
LCD_CtrlWrite_ILI9325(0x0007, 0x0133); // 262K color and display ON
Delay(5000);
}


void LCD_EnterSleep_ILI9325(void)
{
LCD_CtrlWrite_ILI9325(0x0007, 0x0000); // display OFF
//************* Power OFF sequence **************//
LCD_CtrlWrite_ILI9325(0x0010, 0x0080); // SAP, BT[3:0], APE, AP, DSTB, SLP
LCD_CtrlWrite_ILI9325(0x0011, 0x0000); // DC1[2:0], DC0[2:0], VC[2:0]
LCD_CtrlWrite_ILI9325(0x0012, 0x0000); // VREG1OUT voltage
LCD_CtrlWrite_ILI9325(0x0013, 0x0000); // VDV[4:0] for VCOM amplitude
Delay(100000); // Dis-charge capacitor power voltage
LCD_CtrlWrite_ILI9325(0x0010, 0x0082); // SAP, BT[3:0], APE, AP, DSTB, SLP
}

/*****************************************************/
void SET_StartAddress(u16 x,u16 y) {
LCD_CtrlWrite_ILI9325(0x0020,x);//x  GDDRAM address set
LCD_CtrlWrite_ILI9325(0x0021,y);//y  GDDRAM address set
}


/*****************************************************/
void SET_Windows(u16 hs,u16 he,u16 vs,u16 ve){

  LCD_CtrlWrite_ILI9325(0x0050, hs); // Horizontal GRAM Start Address
  LCD_CtrlWrite_ILI9325(0x0051, he); // Horizontal GRAM End Address
  LCD_CtrlWrite_ILI9325(0x0052, vs); // Vertical GRAM Start Address
  LCD_CtrlWrite_ILI9325(0x0053, ve); // Vertical GRAM Start Address
  LCD_CtrlWrite_ILI9325(0x0020, hs);//x  GDDRAM address set
  LCD_CtrlWrite_ILI9325(0x0021, vs);//y  GDDRAM address set
}


/******************************************************/
void LCD_Clean(u16 data){
u32 i;
nCS;nRS;
BUS=0x0022;
nWR;WR;RS;   
for(i=0;i<76800;i++)LCD_WriteData_ILI9325();        
CS;
}

/******************************************************/
void LCD_StartWrite(void){
 nRS;
 BUS=0x0022;
 nWR;
 WR;
 RS;   
}

/******************************************************/
void LCD_Ver(void){
LCD_CtrlWrite_ILI9325(0x0003, 0x0038); // set GRAM write direction and BGR=1.
}


/******************************************************/
void LCD_Hor(void){
LCD_CtrlWrite_ILI9325(0x0003, 0x0030); // set GRAM write direction and BGR=1.
}
